/* ----------------------------------
 * Menu Controll
 * ---------------------------------- */
function activeMenu(itemName, eeOnly) {
	$(".menu-item").removeClass("is-active");
	$(".menu-" + itemName).addClass("is-active");

	if (eeOnly) {
		$(".iplass-header .eeonly").show();
	}
}

/* ----------------------------------
 * Custom Scripts
 * ---------------------------------- */
$(function(){
	var scrollTimer = null;

	initContent();

	function initContent() {
		//コンテンツをmdl配下に移動
		var $iplassContent = $(".iplass-main-content");

		$("#content").children().each(function(index, element) {
			$(element).appendTo($iplassContent);
		});

		//toc制御
		if ($("#toc").children().length > 0) {
			//tocをdrawerにコピー
			var $iplassDrawer = $(".iplass-navigation");
			$("#toc").children().each(function(index, element) {
				$(element).clone(true,true).appendTo($iplassDrawer);
			});
			$("a", $iplassDrawer).addClass("iplass-navigation__link mdl-navigation__link");

			//drawerのlinkがクリックされたらdrawerを閉じる
			$(".iplass-navigation__link").each(function(index, element) {
				$(element).click(function(event) {
					document.getElementById("iplass-layout").MaterialLayout.toggleDrawer();
				});
			});

			//tocをmdl配下に移動
			var $iplassToc = $(".iplass-toc");
			$("#toc").children().each(function(index, element) {
				$(element).appendTo($iplassToc);
			});
		} else {
			$("body").addClass("iplass-no-toc");
		}

		$("#header").remove();
		$("#content").remove();
		$("#toc").remove();

		var $backToTop = $(".back-to-top");
		$(".mdl-layout__content").scroll(function() {
			$(".mdl-layout__content").scrollTop() > 0 ? $backToTop.hasClass("shown") || $backToTop.addClass("shown") : $backToTop.hasClass("shown") && $backToTop.removeClass("shown")
		});
		$backToTop.click(function(event) {
			event.preventDefault();

			// スムーズにスクロールする
			$(".mdl-layout__content").animate({"scrollTop":0}, "slow");
		});


		//ヘッダ部の微調整
		$(".mdl-layout__content").scroll(function() {
			//0秒ごとに処理(とりあえず0)
			if(scrollTimer == null) {
				//セットタイムアウトを設定
				scrollTimer = setTimeout(function() {
					if ($(".iplass-header").hasClass("is-compact")) {
						$(".iplass-content").addClass("is-compact");
					} else {
						$(".iplass-content").removeClass("is-compact");
					}
					scrollTimer = null;
				}, 0);
			}
		});

		//mdl-layout--fixed-headerだとAnchorによる移動がうまくいかないので対応
		//初回表示時にhash指定されている場合
		var hash = $(window).get(0).location.hash;
		if (hash != "") {
			moveToHash();
		}
		//browser backによる変更対応
		$(window).on('hashchange', function(e){
			moveToHash();
		});

		$("body").addClass("loaded");
	}

	/*
	 * 指定されたhashにスクロールする
	 */
	function moveToHash() {

		var hash = $(window).get(0).location.hash;

		var offsetTop = 0;
		if (hash != "") {
			//hashをdecodeしないとFirefoxでうまくいかない
			var decodeHash = decodeURIComponent(hash);
			//offsetTop = $(decode).offset().top;
			offsetTop = $(decodeHash).get(0).offsetTop;
		}
		//mdl-layout__contentをスクロール
		$(".mdl-layout__content").scrollTop(offsetTop);
	}
});
